VAR

  word _Row, _Col, _length
  byte bouncing


PUB Enable
  SetLength(||_length)
  bouncing := false

PUB EnablePos(Row, Col, Length)
  SetRow(Row)
  SetCol(Col)
  SetLength(||Length)
  bouncing := false

PUB Disable
  SetLength(-||_length)

PUB SetPostition(Row, Col)
  SetRow(Row)
  SetCol(Col)

PUB SetRow(Row)
  _Row := Row
  
PUB SetCol(Col)
  _Col := Col

PUB SetLength(Length)
  _Length := Length

PUB GetRow
  return _Row

PUB GetCol
  return _Col

PUB GetLength
  return _length

PUB IsActive
  return _length > 0

PUB CollisionDetection(Row, Col)
  if _length =< 0
    bouncing := false
    return false
    
  if _Row > (Row + 1)
    bouncing := false
    return false
    
  if _Col > (Col + 1)
    bouncing := false
    return false

  if _Row + 1 < Row
    bouncing := false
    return false

  if _Col + _length < Col
   bouncing := false
    return false

  if !bouncing
    bouncing := true
    return true

  return false

PUB TopBottomCollision(Row, Col)
  if (_length =< 0) | (_length > 2000) | (_Col > Col) | ((_Col + _length) < Col) 
    bouncing := false
    return false
    
  if _Row > (Row + 1)
    bouncing := false
    return false          

  if _Row < Row
    bouncing := false
    return false      

  if !bouncing
    bouncing := true
    return true

  return false

PUB SidesCollision(Row, Col)
  if (_length =< 0) | (_length > 2000) | (_Row > Row) | (_Row < (Row + 1))
    bouncing := false
    return false 
    
  if _Col > Col
    bouncing := false
    return false   

  if (_Col + _length) < Col
    bouncing := false
    return false

  if !bouncing
    bouncing := true
    return true

  return false